using System;
using System.Collections;
using System.Text;

namespace SparseArray
{
  class Program
  {
    static void Main(string[] args)
    {
      SparseArray spArr = new SparseArray();

      spArr[1, 1] = 5.5;

      double d1 = spArr[1, 1];
      double d2 = spArr[10, 10];

      Console.WriteLine("Zahl 1: {0}   Zahl 2: {1}   Summe: {2}", d1, d2, spArr.ArraySum);
    }
  }

  class SparseArray
  {
    private SortedList list = new SortedList();

    public double this[int i1, int i2]
    {
      get
      {
        long ll = ((long)i1) << 32 + i2;

        int iPos = list.IndexOfKey(ll);

        if (iPos > -1)
        {
          return (double)list.GetByIndex(iPos);
        }

        return 0.0;
      }
      set
      {
        long ll = ((long)i1) << 32 + i2;

        int iPos = list.IndexOfKey(ll);

        if (iPos < 0)
        {
          list.Add(ll, value);
          return;
        }

        list.SetByIndex(iPos, value);
      }
    }

    public double ArraySum
    {
      get
      {
        double dSum = 0.0;

        for(int i = 0; i < list.Count; i++)
        {
          dSum += (double)list.GetByIndex(i);
        }

        return dSum;
      }
    }
  }
}
